com.io7m.r2.core.shaders.types

## Class R2ShaderFilterVerifier<M>

- java.lang.Object
- - com.io7m.r2.core.shaders.types.R2ShaderFilterVerifier<M>

- Type Parameters:
    `M` - See `R2ShaderFilterType`
  All Implemented Interfaces:
    com.io7m.jcanephora.core.JCGLResourceUsableType, R2DeletableType, R2ShaderFilterType<M>, R2ShaderFilterUsableType<M>, R2ShaderScreenType<M>, R2ShaderScreenUsableType<M>, R2ShaderType<M>, R2ShaderUsableType<M>

      public final class R2ShaderFilterVerifier<M>
      extends Object
      implements R2ShaderFilterType<M>

  A verifier for filter shaders; a type that verifies that a renderer has called all of the required methods in the correct order.

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `delete(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)` Delete the current object.
    `boolean` | `isDeleted()`
    `static <M> R2ShaderFilterType<M>` | `newVerifier(R2ShaderFilterType<M> s)` Construct a new verifier for the given shader.
    `void` | `onActivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)` Activate the shader for rendering.
    `void` | `onDeactivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)` Deactivate the shader.
    `void` | `onReceiveFilterValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g, R2ShaderParametersFilterType<M> parameters)` Set filter values.
    `void` | `onValidate()` Validate the shader prior to executing a draw call.
    `long` | `shaderID()`
    `Class<M>` | `shaderParametersType()`
    `com.io7m.jcanephora.core.JCGLProgramShaderUsableType` | `shaderProgram()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### newVerifier

          public static <M> R2ShaderFilterType<M> newVerifier(R2ShaderFilterType<M> s)

      Construct a new verifier for the given shader.
      Type Parameters:
        `M` - See `R2ShaderLightSingleType`
      Parameters:
        `s` - The shader
      Returns:
        A new verifier

    - #### delete

          public void delete(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)
                      throws R2Exception

      Description copied from interface: `R2DeletableType`
      Delete the current object.
      Specified by:
        `delete` in interface `R2DeletableType`
      Parameters:
        `g` - An OpenGL interface
      Throws:
        `R2Exception` - On errors

    - #### isDeleted

          public boolean isDeleted()

      Specified by:
        `isDeleted` in interface `com.io7m.jcanephora.core.JCGLResourceUsableType`

    - #### shaderID

          public long shaderID()

      Specified by:
        `shaderID` in interface `R2ShaderUsableType<M>`
      Returns:
        The unique shader ID

    - #### shaderParametersType

          public Class<M> shaderParametersType()

      Specified by:
        `shaderParametersType` in interface `R2ShaderUsableType<M>`
      Returns:
        The shader parameter type

    - #### shaderProgram

          public com.io7m.jcanephora.core.JCGLProgramShaderUsableType shaderProgram()

      Specified by:
        `shaderProgram` in interface `R2ShaderUsableType<M>`
      Returns:
        The compiled shader program

    - #### onActivate

          public void onActivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)

      Description copied from interface: `R2ShaderUsableType`
      Activate the shader for rendering.
      Specified by:
        `onActivate` in interface `R2ShaderUsableType<M>`
      Parameters:
        `g` - A GL interface

    - #### onValidate

          public void onValidate()
                          throws R2ExceptionShaderValidationFailed

      Description copied from interface: `R2ShaderUsableType`
      Validate the shader prior to executing a draw call. This method exists so that shader implementations can check that the caller has called all required methods before drawing.
      Specified by:
        `onValidate` in interface `R2ShaderUsableType<M>`
      Throws:
        `R2ExceptionShaderValidationFailed` - If validation fails

    - #### onDeactivate

          public void onDeactivate(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g)

      Description copied from interface: `R2ShaderUsableType`
      Deactivate the shader.
      Specified by:
        `onDeactivate` in interface `R2ShaderUsableType<M>`
      Parameters:
        `g` - A GL interface

    - #### onReceiveFilterValues

          public void onReceiveFilterValues(com.io7m.jcanephora.core.api.JCGLInterfaceGL33Type g,
                                            R2ShaderParametersFilterType<M> parameters)

      Description copied from interface: `R2ShaderFilterUsableType`

      Set filter values.

      This method will be called exactly once between calls to `R2ShaderUsableType.onActivate(JCGLInterfaceGL33Type)` and `R2ShaderUsableType.onValidate()`.

      Specified by:
        `onReceiveFilterValues` in interface `R2ShaderFilterUsableType<M>`
      Parameters:
        `g` - A texture interface
        `parameters` - The current filter parameters

Copyright © 2017 <code@io7m.com> http://io7m.com